//
//  MMSPersistentObjectObserver.h
//  MMSBase
//
//  Created by John Fox on 9/15/08.
//  Copyright 2008 GroupSmarts, LLC. All rights reserved.
//

#import <Foundation/Foundation.h>

@class MMSPersistentObject;

@interface MMSPersistentObjectObserver : NSObject
{
	NSUndoManager *undoManager;
}

+ (MMSPersistentObjectObserver *)sharedObserver;
+ (NSDictionary *)dataModelDict;

- (NSArray *)observeableKeysForObject:(MMSPersistentObject *)anObject;
- (void)registerObject:(MMSPersistentObject *)anObject;
- (void)unregisterObject:(MMSPersistentObject *)anObject;

- (void)changeKeyPath:(NSString *)aKeyPath
			 ofObject:(id)anObject
			  toValue:(id)aValue;
//
// Accessors
//
- (NSUndoManager *)undoManager;
- (void)setUndoManager:(NSUndoManager *)anUndoManager;

@end
