/* MMSPersonLabelViewOwner */

#import <Cocoa/Cocoa.h>

@class MMSActiveTextField;

@interface MMSPersonLabelViewOwner : NSObject
{
    IBOutlet NSButton *abButton;
    IBOutlet MMSActiveTextField *personLabelField;
    IBOutlet NSView *personLabelView;
    IBOutlet NSView *captionTextViewContainer;
    IBOutlet NSView *xmpEditView;
    IBOutlet NSButton *captionToggleButton;
	IBOutlet NSButton *zoomInButton;
    IBOutlet NSButton *deleteButton;
	IBOutlet NSTextView *captionTextView;
	IBOutlet NSTextView *xmpCaptionTextView;
	IBOutlet NSTextView *xmpPersonNameTextField;

    id selectionMarker;
    BOOL captionEditorIsVisible;
	BOOL isEditingXMP;
}

+(id)new;

// Configuration
- (void)adjustTextFieldSize;
- (void)adjustCaptionEditorViewPosition;
- (void)removeSubviews;
- (void)deselectAllMarkers;
- (void)showAllMarkers;
- (void)hideAllMarkers;
- (void)positionAndDipslayView:(NSView *)aView;
- (void)updatePersonLabelViewPosition;

// Action
- (void)closeCaptionEditorView;
- (void)showPeoplePicker:(id)sender;
- (IBAction)closeCaptionEditor:(id)sender;
- (IBAction)toggleCaptionEditor:(id)sender;
- (IBAction)deleteMarker:(id)sender;
- (void)showCaptionEditor;
- (void)didClickZoomInButton:(id)sender;
- (void)showOrHideZoomInButton:(BOOL)shouldShow;
- (void)adjustZoomInButtonPosition;
- (void)showOrHideDeleteButton:(BOOL)shouldShow;
- (void)adjustDeleteButtonPosition;

// Accessors

- (BOOL)isEditingXMP;
- (void)setIsEditingXMP:(BOOL)flag;

- (NSView *)personLabelView;
- (MMSActiveTextField *)personLabelField;

- (id)selectionMarker;
- (void)setSelectionMarker:(id)aMarker;

- (NSView *)annotationView;
- (id)editController;

@end
