//
//  MMSPersonLink.h
//  MemoryMiner
//
//  Created by John Fox on 1/25/05.
//  Copyright 2005 MemoryMiner Software. All rights reserved.
//

#import "MMSPersistentObject.h"

#import "MMSPerson.h"
#import "MMSPersonRelationshipType.h"

#import <Foundation/Foundation.h>


@interface MMSPersonLink : MMSPersistentObject 
{
    MMSPerson *sourcePerson;
    MMSPerson *destinationPerson;
    MMSPersonRelationshipType *relationshipType;
    BOOL isFormer;
}

//
// Fetching and creation
//
+ (MMSPersonLink *)newWithSourcePerson:(MMSPerson *)aSourcePerson
                      destination:(MMSPerson *)aDestPerson
                 relationshipType:(MMSPersonRelationshipType *)aRelationshipType;

+ (MMSPersonLink *)newOrExistingWithSourcePerson:(MMSPerson *)aSourcePerson
                                    destination:(MMSPerson *)aDestPerson
                               relationshipType:(MMSPersonRelationshipType *)aRelationshipType;

+ (MMSPersonLink *)linkJoiningSourcePerson:(MMSPerson *)aSourcePerson
                        destinationPerson:(MMSPerson *)aDestPerson;


//
// Accessors
//
- (MMSPerson *)sourcePerson;
- (void)setSourcePerson:(MMSPerson *)aSourcePerson;

- (MMSPerson *)destinationPerson;
- (void)setDestinationPerson:(MMSPerson *)aDestinationPerson;

- (BOOL)isFormer;
- (void)setIsFormer:(BOOL)flag;

- (MMSPersonRelationshipType *)relationshipType;
- (void)setRelationshipType:(MMSPersonRelationshipType *)aRelationshipType;


@end
