// MMSPlugin.h
//
// Author: John C. Fox
// Date: Mon 26-Dec-2005
//
// Copyright (c) 2005, GroupSmarts. All rights reserved.

#import <Foundation/Foundation.h>

@interface MMSPlugin: NSObject
{
@private
	NSDictionary *infoDictionary;
	NSBundle *loadedBundle;
}

// Plugin extension

+ (NSString *)pluginExtension;
+ (void)setPluginExtension:(NSString *)extStr;

// Loaded plugins

+ (NSArray *)loadedPlugins;
+ (MMSPlugin *)pluginNamed:(NSString *)aName;

// Loading plugins

+ (void)loadAllPlugins;
+ (void)loadPluginAtPath:(NSString *)aPath;
+ (void)addLoadedPlugin:(MMSPlugin *)aPlugin;

// Initialization/deallocation

- (id)initWithPluginAtPath:(NSString *)aPath;
- (void)dealloc;

// Accessors

- (NSDictionary *)infoDictionary;
- (void)setInfoDictionary:(NSDictionary *)anObject;

- (NSBundle *)loadedBundle;
- (void)setLoadedBundle:(NSBundle *)aBundle;

// Debugging

- (NSString *)description;

// Activation

- (void)activate;

@end
