//
//  NSImage_Categories.h
//  MemoryMiner
//
//  Created by John Fox on 10/3/04.
//  Copyright 2004 MemoryMiner Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface NSImage (JCFCategories) 

+ (NSImage *)imageAtFullPixelSizeFromURL:(NSURL *)aURL;

+ (NSImage *)fastImageFromPath:(NSString *)aFilePath
				   boundingBox:(NSSize)aBoundingBox;

+ (NSSize)sizeOfImageAtURL:(NSURL *)aURL;
+ (NSSize)imageSizeForFileAtURL:(NSURL *)anURL;

- (NSImageRep *)chunkyPixelRepWithSize:(NSSize)aSize;
- (NSImage *)chunkyPixelImage;
- (NSImage *)chunkyDoubleSizeImage;
- (NSRect)rectScaledToFitInRect:(NSRect)anOuterRect;
- (NSImage *)imageFromRect:(NSRect)rect scaledBy:(CGFloat)scale;

- (NSImage *)smallIconSizedImage;

- (CGFloat)scaleFactorForSize:(NSSize)aSize;

- (NSData *)JPEGDataWithComporessionFactor:(NSNumber *)aCompressionFactor;

- (BOOL)writeJPEGFileToPath:(NSString *)aPath;

- (BOOL)writeJPEGFileToPath:(NSString *)aPath
		   compressionLevel:(NSNumber *)aCompressionLevel;

- (BOOL)exportJPEGFileToPath:(NSString *)aPath
                scaledToSize:(NSSize)aSize;

- (BOOL)exportJPEGFileToPath:(NSString *)aPath
                scaledToSize:(NSSize)aSize;

- (NSImage *)imageScaledToSize:(NSSize)aSize;

- (CIImage *)CIImage;

@end
