//
//  iPhotoLibraryController.h
//  MemoryMiner
//
//  Created by John Fox on 9/28/04.
//  Copyright 2004 MemoryMiner Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "MMSPerson.h"

@interface iPhotoLibraryController : NSObject 
{
	NSDictionary *iPhotoLibraryDict;
    NSDictionary *currentIPhotoLibrary;
    NSMutableDictionary *thumbnailImageCache;
    NSProgressIndicator *progressBar;
    NSTextField *progressTextField;
    NSImageView *currentThumbnailImageView;
    NSMutableArray *newlyCreatedPhotoArray;

}

// Initilaztion
+ (id)sharedInstance;
- (void)readPhotoLibrary;

//
// Accessors
//
- (NSImageView *)currentThumbnailImageView;
- (void)setCurrentThumbnailImageView:(NSImageView *)aView;

- (NSDictionary *)iPhotoLibraryDict;
- (void)setIPhotoLibraryDict:(NSDictionary *)anIPhotoLibraryDict;

- (NSDictionary *)currentIPhotoLibrary;
- (void)setCurrentIPhotoLibrary:(NSDictionary *)aCurrentIPhotoLibrary;

- (NSMutableArray *)newlyCreatedPhotoArray;
- (void)setNewlyCreatedPhotoArray:(NSMutableArray *)anArray;

- (NSProgressIndicator *)progressBar;
- (void)setProgressBar:(NSProgressIndicator *)aProgressBar;

- (NSTextField *)progressTextField;
- (void)setProgressTextField:(NSTextField *)aTextField;

- (NSMutableDictionary *)thumbnailImageCache;
- (void)setThumbnailImageCache:(NSMutableDictionary *)aThumbnailImageCache;

// Conveniences
- (void)synchronizeWithIPhotoLibraryForOwner:(MMSPerson *)aPhotoOwner;
- (NSDictionary *)masterImageDict;
- (NSArray *)iPhotoLibraryArray;
- (NSArray *)iPhotoAlbumNames;
- (NSString *)libraryPath;

- (NSDictionary *)keywordsDict;

// Faces support
- (NSDictionary *)masterFacesDict;
- (float)additionalFaceHeightProportion;
- (float)additionalFaceWidthProportion;
- (NSArray *)facesInfoDictArrayFromIPhotoKey:(NSString *)anIPhotoKey;
- (NSArray *)facesInfoDictArrayFromDBUsingIPhotoKey:(NSString *)anIPhotoKey;


- (NSArray *)keywordsFromIPhotoKey:(NSString *)anIPhotoKey;


- (NSImage *)imageFromIPhotoKey:(NSString *)anIPhotoKey
			substituteThumbnail:(BOOL)substituteThumbnail;

- (NSURL *)urlFromIPhotoKey:(NSString *)anIPhotoKey
		substituteThumbnail:(BOOL)substituteThumbnail;


- (NSDictionary *)latLongDictFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSString *)filePathForKey:(NSString *)anIPhotoKey;
- (NSString *)thumbnailPathForKey:(NSString *)anIPhotoKey;

- (NSURL *)fileURLForKey:(NSString *)anIPhotoKey;
- (NSURL *)thumbnailURLForKey:(NSString *)anIPhotoKey;

- (NSString *)mediaTypeFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSString *)originalPathFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSCalendarDate *)creationDateFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSString *)captionFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSString *)commentFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSDictionary *)dataDictForIPhotoKey:(NSString *)anIPhotoKey;

- (id)metadataValueForKey:(NSString *)aMetadataKey forIPhotoKey:(NSString *)anIPhotoKey;

- (NSCalendarDate *)metadataModDateFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSCalendarDate *)fileModDateFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSString *)iPhotoKeyFromPath:(NSString *)aPath;

- (NSInteger)ratingFromIPhotoKey:(NSString *)anIPhotoKey;

- (NSArray *)currentIPhotoLibKeyList;

- (NSString *)currentIPhotoLibName;

- (NSArray *)iPhotoAlbumNames;

@end
