//
//  SQLDatabasePrivate.h
//  SQLite Test
//
//  Created by Dustin Mierau on Tue Apr 02 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "DC_SQLDatabase.h"

@interface DC_SQLDatabase (Private)

#if DC_SQLITE_VERSION == 3
- (sqlite3 *) sqliteDatabase;
#else
- (sqlite *) sqliteDatabase;
#endif

@end

@interface DC_SQLResult (Private)
- (id)initWithTable:(char**)inTable rows:(NSInteger)inRows columns:(NSInteger)inColumns;
- (void)setLastID:(NSInteger)inLastID;
@end

@interface DC_SQLRowEnumerator : NSEnumerator
{
	DC_SQLResult*	mResult;
	NSInteger			mPosition;
	IMP			mRowAtIndexMethod;
	NSInteger			(*mRowCountMethod)(DC_SQLResult*, SEL);
}

- (id)initWithResult:(DC_SQLResult*)inResult;

@end

@interface DC_SQLRow (Private)
- (id)initWithColumns:(char**)inColumns rowData:(char**)inRowData columns:(NSInteger)inColumnCount;
- (BOOL)valid;
@end

@interface SQLQueryBuilder (Private)


// builds list of the form ('var1', 'var2', 'var3') -- without trailing comma
// doesn't currently handle single quotes appropriately

+ (NSString *)listFromValues:(NSArray *)values;
+ (NSString *)listFromValues:(NSArray *)values wrapInParenthesis:(BOOL)useParens;
+ (NSString *)listFromValues:(NSArray *)values singleQuoteItems:(BOOL)useQuotes;
+ (NSString *)listFromValues:(NSArray *)values singleQuoteItems:(BOOL)useQuotes wrapInParenthesis:(BOOL)useParens;

// builds assignment list of the form (col1 = 'var1', col2 = 'var2', col3 = 'var3') -- without trailing comma

+ (NSString *)assignmentListFromDictionary:(NSDictionary *)columnsAndValues;
+ (NSString *)whereClauseForDictionary: (NSDictionary *)mask;

@end
